/* key-event.c generated by valac 0.46.6, the Vala compiler
 * generated from key-event.vala, do not modify */

/*
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>

typedef enum  {
	SKK_MODIFIER_TYPE_NONE = 0,
	SKK_MODIFIER_TYPE_SHIFT_MASK = 1 << 0,
	SKK_MODIFIER_TYPE_LOCK_MASK = 1 << 1,
	SKK_MODIFIER_TYPE_CONTROL_MASK = 1 << 2,
	SKK_MODIFIER_TYPE_MOD1_MASK = 1 << 3,
	SKK_MODIFIER_TYPE_MOD2_MASK = 1 << 4,
	SKK_MODIFIER_TYPE_MOD3_MASK = 1 << 5,
	SKK_MODIFIER_TYPE_MOD4_MASK = 1 << 6,
	SKK_MODIFIER_TYPE_MOD5_MASK = 1 << 7,
	SKK_MODIFIER_TYPE_LSHIFT_MASK = 1 << 22,
	SKK_MODIFIER_TYPE_RSHIFT_MASK = 1 << 23,
	SKK_MODIFIER_TYPE_USLEEP_MASK = 1 << 24,
	SKK_MODIFIER_TYPE_SUPER_MASK = 1 << 26,
	SKK_MODIFIER_TYPE_HYPER_MASK = 1 << 27,
	SKK_MODIFIER_TYPE_META_MASK = 1 << 28,
	SKK_MODIFIER_TYPE_RELEASE_MASK = 1 << 30
} SkkModifierType;

#define SKK_TYPE_MODIFIER_TYPE (skk_modifier_type_get_type ())

#define SKK_TYPE_KEY_EVENT (skk_key_event_get_type ())
#define SKK_KEY_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SKK_TYPE_KEY_EVENT, SkkKeyEvent))
#define SKK_KEY_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SKK_TYPE_KEY_EVENT, SkkKeyEventClass))
#define SKK_IS_KEY_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SKK_TYPE_KEY_EVENT))
#define SKK_IS_KEY_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SKK_TYPE_KEY_EVENT))
#define SKK_KEY_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SKK_TYPE_KEY_EVENT, SkkKeyEventClass))

typedef struct _SkkKeyEvent SkkKeyEvent;
typedef struct _SkkKeyEventClass SkkKeyEventClass;
typedef struct _SkkKeyEventPrivate SkkKeyEventPrivate;
enum  {
	SKK_KEY_EVENT_0_PROPERTY,
	SKK_KEY_EVENT_NAME_PROPERTY,
	SKK_KEY_EVENT_CODE_PROPERTY,
	SKK_KEY_EVENT_MODIFIERS_PROPERTY,
	SKK_KEY_EVENT_NUM_PROPERTIES
};
static GParamSpec* skk_key_event_properties[SKK_KEY_EVENT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define SKK_KEY_EVENT_TYPE_CODE_KEYVAL_ENTRY (skk_key_event_code_keyval_entry_get_type ())
typedef struct _SkkKeyEventCodeKeyvalEntry SkkKeyEventCodeKeyvalEntry;

#define SKK_KEY_EVENT_TYPE_NAME_KEYVAL_ENTRY (skk_key_event_name_keyval_entry_get_type ())
typedef struct _SkkKeyEventNameKeyvalEntry SkkKeyEventNameKeyvalEntry;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	SKK_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED,
	SKK_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND
} SkkKeyEventFormatError;
#define SKK_KEY_EVENT_FORMAT_ERROR skk_key_event_format_error_quark ()
struct _SkkKeyEvent {
	GObject parent_instance;
	SkkKeyEventPrivate * priv;
};

struct _SkkKeyEventClass {
	GObjectClass parent_class;
};

struct _SkkKeyEventPrivate {
	gchar* _name;
	gunichar _code;
	SkkModifierType _modifiers;
};

struct _SkkKeyEventCodeKeyvalEntry {
	guint key;
	gunichar value;
};

struct _SkkKeyEventNameKeyvalEntry {
	guint key;
	gchar* value;
};

static gint SkkKeyEvent_private_offset;
static gpointer skk_key_event_parent_class = NULL;

GQuark skk_key_event_format_error_quark (void);
GType skk_modifier_type_get_type (void) G_GNUC_CONST;
GType skk_key_event_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SkkKeyEvent, g_object_unref)
static GType skk_key_event_code_keyval_entry_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static SkkKeyEventCodeKeyvalEntry* skk_key_event_code_keyval_entry_dup (const SkkKeyEventCodeKeyvalEntry* self);
static void skk_key_event_code_keyval_entry_free (SkkKeyEventCodeKeyvalEntry* self);
#define SKK_KEYSYMS_Tab ((guint) 0xff09)
#define SKK_KEYSYMS_Return ((guint) 0xff0d)
#define SKK_KEYSYMS_BackSpace ((guint) 0xff08)
static GType skk_key_event_name_keyval_entry_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static SkkKeyEventNameKeyvalEntry* skk_key_event_name_keyval_entry_dup (const SkkKeyEventNameKeyvalEntry* self);
static void skk_key_event_name_keyval_entry_free (SkkKeyEventNameKeyvalEntry* self);
static void skk_key_event_name_keyval_entry_copy (const SkkKeyEventNameKeyvalEntry* self,
                                           SkkKeyEventNameKeyvalEntry* dest);
static void skk_key_event_name_keyval_entry_destroy (SkkKeyEventNameKeyvalEntry* self);
#define SKK_KEYSYMS_Up ((guint) 0xff52)
#define SKK_KEYSYMS_Down ((guint) 0xff54)
#define SKK_KEYSYMS_Left ((guint) 0xff51)
#define SKK_KEYSYMS_Right ((guint) 0xff53)
#define SKK_KEYSYMS_Page_Up ((guint) 0xff55)
#define SKK_KEYSYMS_KP_Page_Up ((guint) 0xff9a)
#define SKK_KEYSYMS_Page_Down ((guint) 0xff56)
#define SKK_KEYSYMS_KP_Page_Down ((guint) 0xff9b)
#define SKK_KEYSYMS_Muhenkan ((guint) 0xff22)
#define SKK_KEYSYMS_Henkan ((guint) 0xff23)
SkkKeyEvent* skk_key_event_new (const gchar* name,
                                gunichar code,
                                SkkModifierType modifiers);
SkkKeyEvent* skk_key_event_construct (GType object_type,
                                      const gchar* name,
                                      gunichar code,
                                      SkkModifierType modifiers);
static void skk_key_event_set_name (SkkKeyEvent* self,
                             const gchar* value);
static void skk_key_event_set_code (SkkKeyEvent* self,
                             gunichar value);
void skk_key_event_set_modifiers (SkkKeyEvent* self,
                                  SkkModifierType value);
SkkKeyEvent* skk_key_event_copy (SkkKeyEvent* self);
const gchar* skk_key_event_get_name (SkkKeyEvent* self);
gunichar skk_key_event_get_code (SkkKeyEvent* self);
SkkModifierType skk_key_event_get_modifiers (SkkKeyEvent* self);
SkkKeyEvent* skk_key_event_new_from_string (const gchar* key,
                                            GError** error);
SkkKeyEvent* skk_key_event_construct_from_string (GType object_type,
                                                  const gchar* key,
                                                  GError** error);
gchar* skk_key_event_to_string (SkkKeyEvent* self);
SkkKeyEvent* skk_key_event_new_from_x_keysym (guint keyval,
                                              SkkModifierType modifiers,
                                              GError** error);
SkkKeyEvent* skk_key_event_construct_from_x_keysym (GType object_type,
                                                    guint keyval,
                                                    SkkModifierType modifiers,
                                                    GError** error);
gboolean skk_key_event_base_equal (SkkKeyEvent* self,
                                   SkkKeyEvent* key);
static void skk_key_event_finalize (GObject * obj);
static void _vala_skk_key_event_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_skk_key_event_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const SkkKeyEventCodeKeyvalEntry SKK_KEY_EVENT_CODE_KEYVALS[3] = {{SKK_KEYSYMS_Tab, (gunichar) '\t'}, {SKK_KEYSYMS_Return, (gunichar) '\n'}, {SKK_KEYSYMS_BackSpace, (gunichar) '\b'}};
static const SkkKeyEventNameKeyvalEntry SKK_KEY_EVENT_NAME_KEYVALS[10] = {{SKK_KEYSYMS_Up, "Up"}, {SKK_KEYSYMS_Down, "Down"}, {SKK_KEYSYMS_Left, "Left"}, {SKK_KEYSYMS_Right, "Right"}, {SKK_KEYSYMS_Page_Up, "Page_Up"}, {SKK_KEYSYMS_KP_Page_Up, "Page_Up"}, {SKK_KEYSYMS_Page_Down, "Page_Down"}, {SKK_KEYSYMS_KP_Page_Down, "Page_Down"}, {SKK_KEYSYMS_Muhenkan, "lshift"}, {SKK_KEYSYMS_Henkan, "rshift"}};

GQuark
skk_key_event_format_error_quark (void)
{
	return g_quark_from_static_string ("skk-key-event-format-error-quark");
}

/**
     * A set of bit-flags to indicate the state of modifier keys.
     */
GType
skk_modifier_type_get_type (void)
{
	static volatile gsize skk_modifier_type_type_id__volatile = 0;
	if (g_once_init_enter (&skk_modifier_type_type_id__volatile)) {
		static const GFlagsValue values[] = {{SKK_MODIFIER_TYPE_NONE, "SKK_MODIFIER_TYPE_NONE", "none"}, {SKK_MODIFIER_TYPE_SHIFT_MASK, "SKK_MODIFIER_TYPE_SHIFT_MASK", "shift-mask"}, {SKK_MODIFIER_TYPE_LOCK_MASK, "SKK_MODIFIER_TYPE_LOCK_MASK", "lock-mask"}, {SKK_MODIFIER_TYPE_CONTROL_MASK, "SKK_MODIFIER_TYPE_CONTROL_MASK", "control-mask"}, {SKK_MODIFIER_TYPE_MOD1_MASK, "SKK_MODIFIER_TYPE_MOD1_MASK", "mod1-mask"}, {SKK_MODIFIER_TYPE_MOD2_MASK, "SKK_MODIFIER_TYPE_MOD2_MASK", "mod2-mask"}, {SKK_MODIFIER_TYPE_MOD3_MASK, "SKK_MODIFIER_TYPE_MOD3_MASK", "mod3-mask"}, {SKK_MODIFIER_TYPE_MOD4_MASK, "SKK_MODIFIER_TYPE_MOD4_MASK", "mod4-mask"}, {SKK_MODIFIER_TYPE_MOD5_MASK, "SKK_MODIFIER_TYPE_MOD5_MASK", "mod5-mask"}, {SKK_MODIFIER_TYPE_LSHIFT_MASK, "SKK_MODIFIER_TYPE_LSHIFT_MASK", "lshift-mask"}, {SKK_MODIFIER_TYPE_RSHIFT_MASK, "SKK_MODIFIER_TYPE_RSHIFT_MASK", "rshift-mask"}, {SKK_MODIFIER_TYPE_USLEEP_MASK, "SKK_MODIFIER_TYPE_USLEEP_MASK", "usleep-mask"}, {SKK_MODIFIER_TYPE_SUPER_MASK, "SKK_MODIFIER_TYPE_SUPER_MASK", "super-mask"}, {SKK_MODIFIER_TYPE_HYPER_MASK, "SKK_MODIFIER_TYPE_HYPER_MASK", "hyper-mask"}, {SKK_MODIFIER_TYPE_META_MASK, "SKK_MODIFIER_TYPE_META_MASK", "meta-mask"}, {SKK_MODIFIER_TYPE_RELEASE_MASK, "SKK_MODIFIER_TYPE_RELEASE_MASK", "release-mask"}, {0, NULL, NULL}};
		GType skk_modifier_type_type_id;
		skk_modifier_type_type_id = g_flags_register_static ("SkkModifierType", values);
		g_once_init_leave (&skk_modifier_type_type_id__volatile, skk_modifier_type_type_id);
	}
	return skk_modifier_type_type_id__volatile;
}

static inline gpointer
skk_key_event_get_instance_private (SkkKeyEvent* self)
{
	return G_STRUCT_MEMBER_P (self, SkkKeyEvent_private_offset);
}

/**
         * Create a key event.
         *
         * @param name a key name
         * @param code a character code
         * @param modifiers state of modifier keys
         *
         * @return a new KeyEvent
         */
SkkKeyEvent*
skk_key_event_construct (GType object_type,
                         const gchar* name,
                         gunichar code,
                         SkkModifierType modifiers)
{
	SkkKeyEvent * self = NULL;
	self = (SkkKeyEvent*) g_object_new (object_type, NULL);
	skk_key_event_set_name (self, name);
	skk_key_event_set_code (self, code);
	skk_key_event_set_modifiers (self, modifiers);
	return self;
}

SkkKeyEvent*
skk_key_event_new (const gchar* name,
                   gunichar code,
                   SkkModifierType modifiers)
{
	return skk_key_event_construct (SKK_TYPE_KEY_EVENT, name, code, modifiers);
}

/**
         * Create a copy of the key event.
         *
         * @return a new KeyEvent
         */
SkkKeyEvent*
skk_key_event_copy (SkkKeyEvent* self)
{
	const gchar* _tmp0_;
	gunichar _tmp1_;
	SkkModifierType _tmp2_;
	SkkKeyEvent* _tmp3_;
	SkkKeyEvent* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	_tmp1_ = self->priv->_code;
	_tmp2_ = self->priv->_modifiers;
	_tmp3_ = skk_key_event_new (_tmp0_, _tmp1_, _tmp2_);
	result = _tmp3_;
	return result;
}

/**
         * Create a key event from string.
         *
         * @param key a string representation of a key event
         *
         * @return a new KeyEvent
         */
static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	result = g_utf8_get_char (((gchar*) self) + index);
	return result;
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

SkkKeyEvent*
skk_key_event_construct_from_string (GType object_type,
                                     const gchar* key,
                                     GError** error)
{
	SkkKeyEvent * self = NULL;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (key != NULL, NULL);
	self = (SkkKeyEvent*) g_object_new (object_type, NULL);
	if (g_str_has_prefix (key, "(")) {
		_tmp0_ = g_str_has_suffix (key, ")");
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar** strv = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		gint strv_length1;
		gint _strv_size_;
		gint index = 0;
		gchar** _tmp39_;
		gint _tmp39__length1;
		const gchar* _tmp40_;
		gunichar _tmp41_ = 0U;
		const gchar* _tmp42_;
		_tmp1_ = string_slice (key, (glong) 1, (glong) -1);
		_tmp2_ = _tmp1_;
		_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, " ", 0);
		_tmp5_ = _tmp4_;
		_tmp5__length1 = _vala_array_length (_tmp3_);
		_g_free0 (_tmp2_);
		strv = _tmp5_;
		strv_length1 = _tmp5__length1;
		_strv_size_ = strv_length1;
		index = 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gchar** _tmp8_;
				gint _tmp8__length1;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = index;
					index = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = strv;
				_tmp8__length1 = strv_length1;
				if (!(index < (_tmp8__length1 - 1))) {
					break;
				}
				_tmp9_ = strv;
				_tmp9__length1 = strv_length1;
				_tmp10_ = _tmp9_[index];
				if (g_strcmp0 (_tmp10_, "control") == 0) {
					SkkModifierType _tmp11_;
					_tmp11_ = self->priv->_modifiers;
					skk_key_event_set_modifiers (self, _tmp11_ | SKK_MODIFIER_TYPE_CONTROL_MASK);
				} else {
					gchar** _tmp12_;
					gint _tmp12__length1;
					const gchar* _tmp13_;
					_tmp12_ = strv;
					_tmp12__length1 = strv_length1;
					_tmp13_ = _tmp12_[index];
					if (g_strcmp0 (_tmp13_, "meta") == 0) {
						SkkModifierType _tmp14_;
						_tmp14_ = self->priv->_modifiers;
						skk_key_event_set_modifiers (self, _tmp14_ | SKK_MODIFIER_TYPE_META_MASK);
					} else {
						gchar** _tmp15_;
						gint _tmp15__length1;
						const gchar* _tmp16_;
						_tmp15_ = strv;
						_tmp15__length1 = strv_length1;
						_tmp16_ = _tmp15_[index];
						if (g_strcmp0 (_tmp16_, "hyper") == 0) {
							SkkModifierType _tmp17_;
							_tmp17_ = self->priv->_modifiers;
							skk_key_event_set_modifiers (self, _tmp17_ | SKK_MODIFIER_TYPE_HYPER_MASK);
						} else {
							gchar** _tmp18_;
							gint _tmp18__length1;
							const gchar* _tmp19_;
							_tmp18_ = strv;
							_tmp18__length1 = strv_length1;
							_tmp19_ = _tmp18_[index];
							if (g_strcmp0 (_tmp19_, "super") == 0) {
								SkkModifierType _tmp20_;
								_tmp20_ = self->priv->_modifiers;
								skk_key_event_set_modifiers (self, _tmp20_ | SKK_MODIFIER_TYPE_SUPER_MASK);
							} else {
								gchar** _tmp21_;
								gint _tmp21__length1;
								const gchar* _tmp22_;
								_tmp21_ = strv;
								_tmp21__length1 = strv_length1;
								_tmp22_ = _tmp21_[index];
								if (g_strcmp0 (_tmp22_, "alt") == 0) {
									SkkModifierType _tmp23_;
									_tmp23_ = self->priv->_modifiers;
									skk_key_event_set_modifiers (self, _tmp23_ | SKK_MODIFIER_TYPE_MOD1_MASK);
								} else {
									gchar** _tmp24_;
									gint _tmp24__length1;
									const gchar* _tmp25_;
									_tmp24_ = strv;
									_tmp24__length1 = strv_length1;
									_tmp25_ = _tmp24_[index];
									if (g_strcmp0 (_tmp25_, "lshift") == 0) {
										SkkModifierType _tmp26_;
										_tmp26_ = self->priv->_modifiers;
										skk_key_event_set_modifiers (self, _tmp26_ | SKK_MODIFIER_TYPE_LSHIFT_MASK);
									} else {
										gchar** _tmp27_;
										gint _tmp27__length1;
										const gchar* _tmp28_;
										_tmp27_ = strv;
										_tmp27__length1 = strv_length1;
										_tmp28_ = _tmp27_[index];
										if (g_strcmp0 (_tmp28_, "rshift") == 0) {
											SkkModifierType _tmp29_;
											_tmp29_ = self->priv->_modifiers;
											skk_key_event_set_modifiers (self, _tmp29_ | SKK_MODIFIER_TYPE_RSHIFT_MASK);
										} else {
											gchar** _tmp30_;
											gint _tmp30__length1;
											const gchar* _tmp31_;
											_tmp30_ = strv;
											_tmp30__length1 = strv_length1;
											_tmp31_ = _tmp30_[index];
											if (g_strcmp0 (_tmp31_, "usleep") == 0) {
												SkkModifierType _tmp32_;
												_tmp32_ = self->priv->_modifiers;
												skk_key_event_set_modifiers (self, _tmp32_ | SKK_MODIFIER_TYPE_USLEEP_MASK);
											} else {
												gchar** _tmp33_;
												gint _tmp33__length1;
												const gchar* _tmp34_;
												_tmp33_ = strv;
												_tmp33__length1 = strv_length1;
												_tmp34_ = _tmp33_[index];
												if (g_strcmp0 (_tmp34_, "release") == 0) {
													SkkModifierType _tmp35_;
													_tmp35_ = self->priv->_modifiers;
													skk_key_event_set_modifiers (self, _tmp35_ | SKK_MODIFIER_TYPE_RELEASE_MASK);
												} else {
													gchar** _tmp36_;
													gint _tmp36__length1;
													const gchar* _tmp37_;
													GError* _tmp38_;
													_tmp36_ = strv;
													_tmp36__length1 = strv_length1;
													_tmp37_ = _tmp36_[index];
													_tmp38_ = g_error_new (SKK_KEY_EVENT_FORMAT_ERROR, SKK_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED, "unknown modifier %s", _tmp37_);
													_inner_error0_ = _tmp38_;
													if (_inner_error0_->domain == SKK_KEY_EVENT_FORMAT_ERROR) {
														g_propagate_error (error, _inner_error0_);
														strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
														_g_object_unref0 (self);
														return NULL;
													} else {
														strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
														g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
														g_clear_error (&_inner_error0_);
														return NULL;
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
		_tmp39_ = strv;
		_tmp39__length1 = strv_length1;
		_tmp40_ = _tmp39_[index];
		skk_key_event_set_name (self, _tmp40_);
		_tmp42_ = self->priv->_name;
		if (g_utf8_strlen (_tmp42_, (gssize) -1) == 1) {
			const gchar* _tmp43_;
			_tmp43_ = self->priv->_name;
			_tmp41_ = string_get_char (_tmp43_, (glong) 0);
		} else {
			_tmp41_ = (gunichar) '\0';
		}
		skk_key_event_set_code (self, _tmp41_);
		strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
	} else {
		gint index = 0;
		index = string_last_index_of (key, "-", 0);
		if (index > 0) {
			gchar** mods = NULL;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar** _tmp46_;
			gchar** _tmp47_;
			gchar** _tmp48_;
			gint _tmp48__length1;
			gint mods_length1;
			gint _mods_size_;
			gchar** _tmp49_;
			gint _tmp49__length1;
			gchar* _tmp59_;
			gchar* _tmp60_;
			gunichar _tmp61_ = 0U;
			const gchar* _tmp62_;
			_tmp44_ = string_substring (key, (glong) 0, (glong) index);
			_tmp45_ = _tmp44_;
			_tmp47_ = _tmp46_ = g_strsplit (_tmp45_, "-", 0);
			_tmp48_ = _tmp47_;
			_tmp48__length1 = _vala_array_length (_tmp46_);
			_g_free0 (_tmp45_);
			mods = _tmp48_;
			mods_length1 = _tmp48__length1;
			_mods_size_ = mods_length1;
			_tmp49_ = mods;
			_tmp49__length1 = mods_length1;
			{
				gchar** mod_collection = NULL;
				gint mod_collection_length1 = 0;
				gint _mod_collection_size_ = 0;
				gint mod_it = 0;
				mod_collection = _tmp49_;
				mod_collection_length1 = _tmp49__length1;
				for (mod_it = 0; mod_it < mod_collection_length1; mod_it = mod_it + 1) {
					gchar* _tmp50_;
					gchar* mod = NULL;
					_tmp50_ = g_strdup (mod_collection[mod_it]);
					mod = _tmp50_;
					{
						const gchar* _tmp51_;
						_tmp51_ = mod;
						if (g_strcmp0 (_tmp51_, "C") == 0) {
							SkkModifierType _tmp52_;
							_tmp52_ = self->priv->_modifiers;
							skk_key_event_set_modifiers (self, _tmp52_ | SKK_MODIFIER_TYPE_CONTROL_MASK);
						} else {
							const gchar* _tmp53_;
							_tmp53_ = mod;
							if (g_strcmp0 (_tmp53_, "A") == 0) {
								SkkModifierType _tmp54_;
								_tmp54_ = self->priv->_modifiers;
								skk_key_event_set_modifiers (self, _tmp54_ | SKK_MODIFIER_TYPE_MOD1_MASK);
							} else {
								const gchar* _tmp55_;
								_tmp55_ = mod;
								if (g_strcmp0 (_tmp55_, "M") == 0) {
									SkkModifierType _tmp56_;
									_tmp56_ = self->priv->_modifiers;
									skk_key_event_set_modifiers (self, _tmp56_ | SKK_MODIFIER_TYPE_META_MASK);
								} else {
									const gchar* _tmp57_;
									_tmp57_ = mod;
									if (g_strcmp0 (_tmp57_, "G") == 0) {
										SkkModifierType _tmp58_;
										_tmp58_ = self->priv->_modifiers;
										skk_key_event_set_modifiers (self, _tmp58_ | SKK_MODIFIER_TYPE_MOD5_MASK);
									}
								}
							}
						}
						_g_free0 (mod);
					}
				}
			}
			_tmp59_ = string_substring (key, (glong) (index + 1), (glong) -1);
			_tmp60_ = _tmp59_;
			skk_key_event_set_name (self, _tmp60_);
			_g_free0 (_tmp60_);
			_tmp62_ = self->priv->_name;
			if (g_utf8_strlen (_tmp62_, (gssize) -1) == 1) {
				const gchar* _tmp63_;
				_tmp63_ = self->priv->_name;
				_tmp61_ = string_get_char (_tmp63_, (glong) 0);
			} else {
				_tmp61_ = (gunichar) '\0';
			}
			skk_key_event_set_code (self, _tmp61_);
			mods = (_vala_array_free (mods, mods_length1, (GDestroyNotify) g_free), NULL);
		} else {
			gunichar _tmp64_ = 0U;
			const gchar* _tmp65_;
			skk_key_event_set_modifiers (self, SKK_MODIFIER_TYPE_NONE);
			skk_key_event_set_name (self, key);
			_tmp65_ = self->priv->_name;
			if (g_utf8_strlen (_tmp65_, (gssize) -1) == 1) {
				const gchar* _tmp66_;
				_tmp66_ = self->priv->_name;
				_tmp64_ = string_get_char (_tmp66_, (glong) 0);
			} else {
				_tmp64_ = (gunichar) '\0';
			}
			skk_key_event_set_code (self, _tmp64_);
		}
	}
	return self;
}

SkkKeyEvent*
skk_key_event_new_from_string (const gchar* key,
                               GError** error)
{
	return skk_key_event_construct_from_string (SKK_TYPE_KEY_EVENT, key, error);
}

/**
         * Convert the KeyEvent to string.
         *
         * @return a string representing the KeyEvent
         */
static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	g_unichar_to_utf8 (self, str);
	result = str;
	return result;
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result = NULL;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len += (gsize) _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len += (gsize) (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp19_ = res;
		_tmp20_ = str_array[0];
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
		ptr = _tmp21_;
		{
			gboolean _tmp22_ = FALSE;
			i = 1;
			_tmp22_ = TRUE;
			while (TRUE) {
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp24_ = ptr;
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
				ptr = _tmp25_;
				_tmp27_ = str_array[i];
				if (_tmp27_ != NULL) {
					const gchar* _tmp28_;
					_tmp28_ = str_array[i];
					_tmp26_ = (const gchar*) _tmp28_;
				} else {
					_tmp26_ = "";
				}
				_tmp29_ = ptr;
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
				ptr = _tmp30_;
			}
		}
		_tmp31_ = res;
		res = NULL;
		result = (gchar*) _tmp31_;
		return result;
	} else {
		gchar* _tmp32_;
		_tmp32_ = g_strdup ("");
		result = _tmp32_;
		return result;
	}
}

gchar*
skk_key_event_to_string (SkkKeyEvent* self)
{
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* _base = NULL;
	gchar* _tmp6_;
	SkkModifierType _tmp7_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_name;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = self->priv->_name;
		_tmp3_ = g_strdup (_tmp2_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	} else {
		gunichar _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = self->priv->_code;
		_tmp5_ = g_unichar_to_string (_tmp4_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = g_strdup (_tmp0_);
	_base = _tmp6_;
	_tmp7_ = self->priv->_modifiers;
	if (_tmp7_ != 0) {
		GeeArrayList* elements = NULL;
		GeeArrayList* _tmp8_;
		SkkModifierType _tmp9_;
		SkkModifierType _tmp11_;
		SkkModifierType _tmp13_;
		SkkModifierType _tmp15_;
		SkkModifierType _tmp17_;
		SkkModifierType _tmp19_;
		SkkModifierType _tmp21_;
		SkkModifierType _tmp23_;
		SkkModifierType _tmp25_;
		GeeArrayList* _tmp27_;
		const gchar* _tmp28_;
		GeeArrayList* _tmp29_;
		gchar** array = NULL;
		GeeArrayList* _tmp30_;
		gint _tmp31_ = 0;
		gpointer* _tmp32_;
		gint array_length1;
		gint _array_size_;
		gchar** _tmp33_;
		gint _tmp33__length1;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		_tmp8_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
		elements = _tmp8_;
		_tmp9_ = self->priv->_modifiers;
		if ((_tmp9_ & SKK_MODIFIER_TYPE_CONTROL_MASK) != 0) {
			GeeArrayList* _tmp10_;
			_tmp10_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, "control");
		}
		_tmp11_ = self->priv->_modifiers;
		if ((_tmp11_ & SKK_MODIFIER_TYPE_META_MASK) != 0) {
			GeeArrayList* _tmp12_;
			_tmp12_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, "meta");
		}
		_tmp13_ = self->priv->_modifiers;
		if ((_tmp13_ & SKK_MODIFIER_TYPE_HYPER_MASK) != 0) {
			GeeArrayList* _tmp14_;
			_tmp14_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, "hyper");
		}
		_tmp15_ = self->priv->_modifiers;
		if ((_tmp15_ & SKK_MODIFIER_TYPE_SUPER_MASK) != 0) {
			GeeArrayList* _tmp16_;
			_tmp16_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, "super");
		}
		_tmp17_ = self->priv->_modifiers;
		if ((_tmp17_ & SKK_MODIFIER_TYPE_MOD1_MASK) != 0) {
			GeeArrayList* _tmp18_;
			_tmp18_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, "alt");
		}
		_tmp19_ = self->priv->_modifiers;
		if ((_tmp19_ & SKK_MODIFIER_TYPE_LSHIFT_MASK) != 0) {
			GeeArrayList* _tmp20_;
			_tmp20_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, "lshift");
		}
		_tmp21_ = self->priv->_modifiers;
		if ((_tmp21_ & SKK_MODIFIER_TYPE_RSHIFT_MASK) != 0) {
			GeeArrayList* _tmp22_;
			_tmp22_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, "rshift");
		}
		_tmp23_ = self->priv->_modifiers;
		if ((_tmp23_ & SKK_MODIFIER_TYPE_USLEEP_MASK) != 0) {
			GeeArrayList* _tmp24_;
			_tmp24_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, "usleep");
		}
		_tmp25_ = self->priv->_modifiers;
		if ((_tmp25_ & SKK_MODIFIER_TYPE_RELEASE_MASK) != 0) {
			GeeArrayList* _tmp26_;
			_tmp26_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, "release");
		}
		_tmp27_ = elements;
		_tmp28_ = _base;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
		_tmp29_ = elements;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, NULL);
		_tmp30_ = elements;
		_tmp32_ = gee_collection_to_array ((GeeCollection*) _tmp30_, &_tmp31_);
		array = _tmp32_;
		array_length1 = _tmp31_;
		_array_size_ = array_length1;
		array_length1 = -1;
		_tmp33_ = array;
		_tmp33__length1 = array_length1;
		_tmp34_ = _vala_g_strjoinv (" ", _tmp33_, (gint) _tmp33__length1);
		_tmp35_ = _tmp34_;
		_tmp36_ = g_strconcat ("(", _tmp35_, NULL);
		_tmp37_ = _tmp36_;
		_tmp38_ = g_strconcat (_tmp37_, ")", NULL);
		_tmp39_ = _tmp38_;
		_g_free0 (_tmp37_);
		_g_free0 (_tmp35_);
		result = _tmp39_;
		array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_free), NULL);
		_g_object_unref0 (elements);
		_g_free0 (_base);
		_g_free0 (_tmp0_);
		return result;
	} else {
		result = _base;
		_g_free0 (_tmp0_);
		return result;
	}
	_g_free0 (_base);
	_g_free0 (_tmp0_);
}

/**
         * Create a key event from an X keysym and modifiers.
         *
         * @param keyval an X keysym
         * @param modifiers modifier mask
         *
         * @return a new KeyEvent
         */
SkkKeyEvent*
skk_key_event_construct_from_x_keysym (GType object_type,
                                       guint keyval,
                                       SkkModifierType modifiers,
                                       GError** error)
{
	SkkKeyEvent * self = NULL;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
	self = (SkkKeyEvent*) g_object_new (object_type, NULL);
	{
		SkkKeyEventNameKeyvalEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
		entry_collection = SKK_KEY_EVENT_NAME_KEYVALS;
		entry_collection_length1 = G_N_ELEMENTS (SKK_KEY_EVENT_NAME_KEYVALS);
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
			SkkKeyEventNameKeyvalEntry entry = {0};
			entry = entry_collection[entry_it];
			{
				SkkKeyEventNameKeyvalEntry _tmp0_;
				_tmp0_ = entry;
				if (_tmp0_.key == keyval) {
					SkkKeyEventNameKeyvalEntry _tmp1_;
					const gchar* _tmp2_;
					_tmp1_ = entry;
					_tmp2_ = _tmp1_.value;
					skk_key_event_set_name (self, _tmp2_);
					break;
				}
			}
		}
	}
	{
		SkkKeyEventCodeKeyvalEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
		entry_collection = SKK_KEY_EVENT_CODE_KEYVALS;
		entry_collection_length1 = G_N_ELEMENTS (SKK_KEY_EVENT_CODE_KEYVALS);
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
			SkkKeyEventCodeKeyvalEntry entry = {0};
			entry = entry_collection[entry_it];
			{
				SkkKeyEventCodeKeyvalEntry _tmp3_;
				_tmp3_ = entry;
				if (_tmp3_.key == keyval) {
					SkkKeyEventCodeKeyvalEntry _tmp4_;
					_tmp4_ = entry;
					skk_key_event_set_code (self, _tmp4_.value);
					break;
				}
			}
		}
	}
	_tmp6_ = self->priv->_name;
	if (_tmp6_ == NULL) {
		_tmp5_ = TRUE;
	} else {
		gunichar _tmp7_;
		_tmp7_ = self->priv->_code;
		_tmp5_ = _tmp7_ == ((gunichar) '\0');
	}
	_vala_assert (_tmp5_, "name == null || code == '\\0'");
	_tmp9_ = self->priv->_name;
	if (_tmp9_ == NULL) {
		gunichar _tmp10_;
		_tmp10_ = self->priv->_code;
		_tmp8_ = _tmp10_ == ((gunichar) '\0');
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		gboolean _tmp11_ = FALSE;
		if (((guint) 0x20) <= keyval) {
			_tmp11_ = keyval < ((guint) 0x7F);
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			skk_key_event_set_code (self, (gunichar) keyval);
		} else {
			GError* _tmp12_;
			_tmp12_ = g_error_new (SKK_KEY_EVENT_FORMAT_ERROR, SKK_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND, "unknown keysym %u", keyval);
			_inner_error0_ = _tmp12_;
			if (_inner_error0_->domain == SKK_KEY_EVENT_FORMAT_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (self);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	skk_key_event_set_modifiers (self, modifiers);
	return self;
}

SkkKeyEvent*
skk_key_event_new_from_x_keysym (guint keyval,
                                 SkkModifierType modifiers,
                                 GError** error)
{
	return skk_key_event_construct_from_x_keysym (SKK_TYPE_KEY_EVENT, keyval, modifiers, error);
}

/**
         * Compare two key events ignoring modifiers.
         *
         * @param key a KeyEvent
         *
         * @return `true` if those base components are equal, `false` otherwise
         */
gboolean
skk_key_event_base_equal (SkkKeyEvent* self,
                          SkkKeyEvent* key)
{
	gboolean _tmp0_ = FALSE;
	gunichar _tmp1_;
	gunichar _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (key != NULL, FALSE);
	_tmp1_ = self->priv->_code;
	_tmp2_ = key->priv->_code;
	if (_tmp1_ == _tmp2_) {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = self->priv->_name;
		_tmp4_ = key->priv->_name;
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

const gchar*
skk_key_event_get_name (SkkKeyEvent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

static void
skk_key_event_set_name (SkkKeyEvent* self,
                        const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, skk_key_event_get_name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, skk_key_event_properties[SKK_KEY_EVENT_NAME_PROPERTY]);
	}
}

gunichar
skk_key_event_get_code (SkkKeyEvent* self)
{
	gunichar result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_code;
	return result;
}

static void
skk_key_event_set_code (SkkKeyEvent* self,
                        gunichar value)
{
	g_return_if_fail (self != NULL);
	if (skk_key_event_get_code (self) != value) {
		self->priv->_code = value;
		g_object_notify_by_pspec ((GObject *) self, skk_key_event_properties[SKK_KEY_EVENT_CODE_PROPERTY]);
	}
}

SkkModifierType
skk_key_event_get_modifiers (SkkKeyEvent* self)
{
	SkkModifierType result;
	SkkModifierType _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_modifiers;
	result = _tmp0_;
	return result;
}

void
skk_key_event_set_modifiers (SkkKeyEvent* self,
                             SkkModifierType value)
{
	g_return_if_fail (self != NULL);
	if (skk_key_event_get_modifiers (self) != value) {
		self->priv->_modifiers = value;
		g_object_notify_by_pspec ((GObject *) self, skk_key_event_properties[SKK_KEY_EVENT_MODIFIERS_PROPERTY]);
	}
}

static SkkKeyEventCodeKeyvalEntry*
skk_key_event_code_keyval_entry_dup (const SkkKeyEventCodeKeyvalEntry* self)
{
	SkkKeyEventCodeKeyvalEntry* dup;
	dup = g_new0 (SkkKeyEventCodeKeyvalEntry, 1);
	memcpy (dup, self, sizeof (SkkKeyEventCodeKeyvalEntry));
	return dup;
}

static void
skk_key_event_code_keyval_entry_free (SkkKeyEventCodeKeyvalEntry* self)
{
	g_free (self);
}

static GType
skk_key_event_code_keyval_entry_get_type (void)
{
	static volatile gsize skk_key_event_code_keyval_entry_type_id__volatile = 0;
	if (g_once_init_enter (&skk_key_event_code_keyval_entry_type_id__volatile)) {
		GType skk_key_event_code_keyval_entry_type_id;
		skk_key_event_code_keyval_entry_type_id = g_boxed_type_register_static ("SkkKeyEventCodeKeyvalEntry", (GBoxedCopyFunc) skk_key_event_code_keyval_entry_dup, (GBoxedFreeFunc) skk_key_event_code_keyval_entry_free);
		g_once_init_leave (&skk_key_event_code_keyval_entry_type_id__volatile, skk_key_event_code_keyval_entry_type_id);
	}
	return skk_key_event_code_keyval_entry_type_id__volatile;
}

static void
skk_key_event_name_keyval_entry_copy (const SkkKeyEventNameKeyvalEntry* self,
                                      SkkKeyEventNameKeyvalEntry* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	(*dest).key = (*self).key;
	_tmp0_ = (*self).value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).value);
	(*dest).value = _tmp1_;
}

static void
skk_key_event_name_keyval_entry_destroy (SkkKeyEventNameKeyvalEntry* self)
{
	_g_free0 ((*self).value);
}

static SkkKeyEventNameKeyvalEntry*
skk_key_event_name_keyval_entry_dup (const SkkKeyEventNameKeyvalEntry* self)
{
	SkkKeyEventNameKeyvalEntry* dup;
	dup = g_new0 (SkkKeyEventNameKeyvalEntry, 1);
	skk_key_event_name_keyval_entry_copy (self, dup);
	return dup;
}

static void
skk_key_event_name_keyval_entry_free (SkkKeyEventNameKeyvalEntry* self)
{
	skk_key_event_name_keyval_entry_destroy (self);
	g_free (self);
}

static GType
skk_key_event_name_keyval_entry_get_type (void)
{
	static volatile gsize skk_key_event_name_keyval_entry_type_id__volatile = 0;
	if (g_once_init_enter (&skk_key_event_name_keyval_entry_type_id__volatile)) {
		GType skk_key_event_name_keyval_entry_type_id;
		skk_key_event_name_keyval_entry_type_id = g_boxed_type_register_static ("SkkKeyEventNameKeyvalEntry", (GBoxedCopyFunc) skk_key_event_name_keyval_entry_dup, (GBoxedFreeFunc) skk_key_event_name_keyval_entry_free);
		g_once_init_leave (&skk_key_event_name_keyval_entry_type_id__volatile, skk_key_event_name_keyval_entry_type_id);
	}
	return skk_key_event_name_keyval_entry_type_id__volatile;
}

static void
skk_key_event_class_init (SkkKeyEventClass * klass,
                          gpointer klass_data)
{
	skk_key_event_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SkkKeyEvent_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_skk_key_event_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_skk_key_event_set_property;
	G_OBJECT_CLASS (klass)->finalize = skk_key_event_finalize;
	/**
	         * The base name of the KeyEvent.
	         *
	         * This is exclusive to {@link code}.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_KEY_EVENT_NAME_PROPERTY, skk_key_event_properties[SKK_KEY_EVENT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	         * The base code of the KeyEvent.
	         *
	         * This is exclusive to {@link name}.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_KEY_EVENT_CODE_PROPERTY, skk_key_event_properties[SKK_KEY_EVENT_CODE_PROPERTY] = g_param_spec_uint ("code", "code", "code", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	         * Modifier mask.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_KEY_EVENT_MODIFIERS_PROPERTY, skk_key_event_properties[SKK_KEY_EVENT_MODIFIERS_PROPERTY] = g_param_spec_flags ("modifiers", "modifiers", "modifiers", SKK_TYPE_MODIFIER_TYPE, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
skk_key_event_instance_init (SkkKeyEvent * self,
                             gpointer klass)
{
	self->priv = skk_key_event_get_instance_private (self);
}

static void
skk_key_event_finalize (GObject * obj)
{
	SkkKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SKK_TYPE_KEY_EVENT, SkkKeyEvent);
	_g_free0 (self->priv->_name);
	G_OBJECT_CLASS (skk_key_event_parent_class)->finalize (obj);
}

/**
     * Object representing a key event.
     */
GType
skk_key_event_get_type (void)
{
	static volatile gsize skk_key_event_type_id__volatile = 0;
	if (g_once_init_enter (&skk_key_event_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SkkKeyEventClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_key_event_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkKeyEvent), 0, (GInstanceInitFunc) skk_key_event_instance_init, NULL };
		GType skk_key_event_type_id;
		skk_key_event_type_id = g_type_register_static (G_TYPE_OBJECT, "SkkKeyEvent", &g_define_type_info, 0);
		SkkKeyEvent_private_offset = g_type_add_instance_private (skk_key_event_type_id, sizeof (SkkKeyEventPrivate));
		g_once_init_leave (&skk_key_event_type_id__volatile, skk_key_event_type_id);
	}
	return skk_key_event_type_id__volatile;
}

static void
_vala_skk_key_event_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	SkkKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SKK_TYPE_KEY_EVENT, SkkKeyEvent);
	switch (property_id) {
		case SKK_KEY_EVENT_NAME_PROPERTY:
		g_value_set_string (value, skk_key_event_get_name (self));
		break;
		case SKK_KEY_EVENT_CODE_PROPERTY:
		g_value_set_uint (value, skk_key_event_get_code (self));
		break;
		case SKK_KEY_EVENT_MODIFIERS_PROPERTY:
		g_value_set_flags (value, skk_key_event_get_modifiers (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_skk_key_event_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	SkkKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SKK_TYPE_KEY_EVENT, SkkKeyEvent);
	switch (property_id) {
		case SKK_KEY_EVENT_NAME_PROPERTY:
		skk_key_event_set_name (self, g_value_get_string (value));
		break;
		case SKK_KEY_EVENT_CODE_PROPERTY:
		skk_key_event_set_code (self, g_value_get_uint (value));
		break;
		case SKK_KEY_EVENT_MODIFIERS_PROPERTY:
		skk_key_event_set_modifiers (self, g_value_get_flags (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

